// DATI GLOBALI
// ############

var areaPolygon, distPolyline;

// MISURAZIONE AREE
// ################
function misuraArea() {
    areaPolygon && map.removeOverlay(areaPolygon);
    // add a areaPolygon to the map with no vertices
    areaPolygon = new GPolygon([], "#0000FF", 2, 1.0, "#0000FF", 0.5);
    map.addOverlay(areaPolygon);
    // register a listener for "endline" event and enable drawing
    GEvent.addListener(areaPolygon, "endline", calculateArea);
    areaPolygon.enableDrawing();
}
function updateAreaPolygon() {
	//Abilita la modifica del poligono creato
    areaPolygon.enableEditing({onEvent: "mouseover"});
    areaPolygon.disableEditing({onEvent: "mouseout"}); 
	//Crea un listener che rilancia la misura ogni volta che un vertice viene spostato
    GEvent.addListener(areaPolygon, "lineupdated",updateArea); 
}
function calculateArea() {
	updateAreaPolygon();
   	areaPolygon.getArea();
   	areaMQ  = areaPolygon.getArea();
	areaKMQ = areaPolygon.getArea()/1000000;
	messaggio = "<center><div class='msgTrue'>"
				+ areaKMQ.toFixed(3)+" kmq<br/>"
				+ "Trascinare i vertici del poligono per modificare l'area misurata"
				+ "</div></center>";
	jQuery("#msgs").hide().html(messaggio).fadeIn("slow"); return false;
}
function updateArea() {
	updateAreaPolygon();
   	areaPolygon.getArea();
   	areaMQ  = areaPolygon.getArea();
	areaKMQ = areaPolygon.getArea()/1000000;
	messaggio = "<center><div class='msgTrue'>"+areaKMQ.toFixed(3)+" kmq<br/>"
	jQuery("#msgs").html(messaggio);
}

// MISURAZIONE DISTANZE
// ####################
function misuraDistanza() {
	distPolyline && map.removeOverlay(distPolyline);
    // add a distPolyline to the map with no vertices
    distPolyline = new GPolyline([], "#0000FF", 2, 1.0);
    map.addOverlay(distPolyline);
    // register a listener for "endline" event and enable drawing
    GEvent.addListener(distPolyline, "endline", calculateLengths);
    distPolyline.enableDrawing();
}
function updateDistPolyline() {
	//Abilita la modifica del poligono creato
    distPolyline.enableEditing({onEvent: "mouseover"});
    distPolyline.disableEditing({onEvent: "mouseout"}); 
	//Crea un listener che rilancia la misura ogni volta che un vertice viene spostato
    GEvent.addListener(distPolyline, "lineupdated",updateLengths); 
}
function calculateLengths() {
	updateDistPolyline()
	distPolyline.getLength();
	distanzaM = distPolyline.getLength();
   	distanzaKM = distPolyline.getLength()/1000;
	if (distanzaKM >= 1) {
		messaggio = "<center><div class='msgTrue'>" + distanzaKM.toFixed(3) + " km</div></centre>";
   		jQuery("#msgs").hide().html(messaggio).fadeIn("slow"); return false;

   	} else {
		messaggio = "<center><div class='msgTrue'>" + distanzaM.toFixed(3) + " m</div></centre>"
   		jQuery("#msgs").hide().html(messaggio).fadeIn("slow"); return false;
   	}
}
function updateLengths() {
	updateDistPolyline()
	distPolyline.getLength();
	distanzaM = distPolyline.getLength();
   	distanzaKM = distPolyline.getLength()/1000;
	if (distanzaKM >= 1) {
		messaggio = "<center><div class='msgTrue'>" + distanzaKM.toFixed(3) + " km</div></centre>";
   		jQuery("#msgs").html(messaggio);

   	} else {
		messaggio = "<center><div class='msgTrue'>" + distanzaM.toFixed(3) + " m</div></centre>"
   		jQuery("#msgs").html(messaggio);
   	}
}
// PULIZIA DEI SEGMENTI E POLIGONI MISURATI
// ########################################
function clearMisure() {
	areaPolygon && map.removeOverlay(areaPolygon);
	distPolyline && map.removeOverlay(distPolyline);
	jQuery("#msgs").hide().html("").fadeIn("slow"); return false;
}
