$(document).ready(function(){
	$( "#poi_tools_tabs" ).tabs();
	$( "button" ).button();
	$( "#poi_cate,#poi_region" ).multiselect({
		multiple: false,
		minWidth:"auto",
		selectedList: 1
	});
	
	var rowid;	//save row ID of the last row selected
	
	//GRID
	jQuery("#poi_grid").jqGrid({ 
		url:'php/retrieve_pois.php', 
		editurl:'php/edit_pois.php',
		datatype: "json", 
		colNames:['Name', 'Region', 'Type','Website','PDF','Lat','Lon','Created by'], 
		colModel:[ 
			{name:'name',index:'name', width:150, search:true, editable:true}, 
			{name:'region',index:'region', width:70, search:true, editable:true, 
				edittype:'select',
				editoptions: {
					value:'Neamt:Neamt;Prahova:Prahova;Dambovita:Dambovita'
			 }
			}, 
			{name:'type',index:'type', width:70, search:true, editable:true,
				edittype:'select',
				editoptions:{
					value:'oras:Oras;nature:Ambiental;cultural:Bun cultural;museum:Muzeu;hotel:Structura de primiere;'+
						  'masivul_bucei_a1:Masivul Bucegi A1;'+
						  'masivul_bucei_a2:Masivul Bucegi A2;'+
						  'masivul_bucei_a3:Masivul Bucegi A3;'+
						  'masivul_bucei_a4:Masivul Bucegi A4;'+
						  'masivul_bucei_a5:Masivul Bucegi A5;'+
						  'masivul_bucei_a6:Masivul Bucegi A6;'+
						  'masivul_bucei_a7:Masivul Bucegi A7;'+
						  'masivul_bucei_a8:Masivul Bucegi A8;'+
						  'masivul_bucei_b1:Masivul Bucegi B1;'+
						  'masivul_bucei_b2:Masivul Bucegi B2;'+
						  'masivul_bucei_b3:Masivul Bucegi B3;'+
						  'piatra_neamt_1:Piatra Neamt 1;'+
						  'tinitul_neamt_1:Tinutul Neamt 1;'+
						  'tinitul_neamt_2:Tinutul Neamt 2;'+
						  'tinitul_neamt_3:Tinutul Neamt 3;'+
						  'tinitul_neamt_4:Tinutul Neamt 4;'+
						  'tinitul_neamt_5:Tinutul Neamt 5;'+
						  'tinitul_neamt_6:Tinutul Neamt 6;'+
						  'tinitul_neamt_7:Tinutul Neamt 7;'+
						  'tinitul_neamt_8:Tinutul Neamt 8;'+
						  'tinitul_neamt_9:Tinutul Neamt 9;'+
						  'road_wine:Drumul vinului;road_fruit:Drumul fructelor;voivodes_path:Drumul Voievozilor'
				}
			}, 
			{name:'website',index:'website', width:90,sortable:false,search:false, editable:true}, 
			{name:'pdf',index:'pdf', width:100,align:"right",sortable:false,search:false, editable:true}, 
			{name:'lat',index:'lat', width:60, sortable:false,search:false, editable:true}, 
			{name:'lon',index:'lon', width:60, sortable:false,search:false, editable:true},
			{name:'creator',index:'creator', width:80, sortable:true,search:true, editable:false}
		], 
		pager:'#pager',
		rowNum:20, 
		rowList:[20,30,50], 
		sortname: 'name', 
		viewrecords: true, 
		sortorder: "asc",
		height:259,
		onSelectRow: function(id){
			if(id && id!==rowid){
				jQuery('#poi_grid').restoreRow(rowid);	//restore last grid row
				rowid=id;	//save current row ID so that when focus is gone it can be restored
			}
		}
	}); 
	//Pager
	jQuery("#poi_grid").jqGrid('navGrid','#pager',
		{edit:false,add:false,del:false,search:false,refresh:false}
	)
	//Custom buttons
	.navButtonAdd('#pager',{
		caption:"",
        title:"Search", 
        buttonicon:"ui-icon search", 
        onClickButton: function(){ 
        	jQuery("#poi_grid").jqGrid('searchGrid', {
        		sopt:['eq','ne','cn','bw','bn'],
				//multipleSearch:true
			});
        }, 
        position:"last"
     })
	.navButtonAdd('#pager',{
		caption:"",
        title:"Edit the selected record", 
        buttonicon:"ui-icon edit", 
        onClickButton: function(){ 
			//alert(rowid);
			if(rowid==undefined){
				jQuery("#notification").html("You must select a record to edit!");	
			} else {
				jQuery("#poi_grid").jqGrid('editGridRow', rowid );
				jQuery("#notification").html("Notification area");	
			}
        }, 
        position:"last"
     })
     .navButtonAdd('#pager',{
		caption:"",
        title:"Delete the selected record", 
        buttonicon:"ui-icon delete", 
        onClickButton: function(){ 
        	if(rowid==undefined){
				jQuery("#notification").html("You must select a record to delete!");	
			} else {
				jQuery("#poi_grid").jqGrid('delGridRow', rowid );
				jQuery("#notification").html("Notification area");	
			}

        }, 
        position:"last"
     });
	//Filter toolbar
    //jQuery("#poi_grid").jqGrid('filterToolbar',{ignoreCase:true,stringResult:true});
    //Larghezza
	$("#poi_grid").setGridWidth("795");
	
});