var map;
var markers = [];

function initialize() {
	// Map Options
	var mapOptions = {
		disableDefaultUI: true,
		panControl: false,
  		zoomControl: true,
  		zoomControlOptions: {
      		style: google.maps.ZoomControlStyle.SMALL
		},
  		mapTypeControl: true,
  		scaleControl: true,
  		streetViewControl: false,
  		overviewMapControl: true,
    		center: new google.maps.LatLng(45.9761,24.8320),
        	zoom: 6
	};
  	map = new google.maps.Map(document.getElementById('map_canvas'), mapOptions);
  	
  	google.maps.event.addListener(map, 'click', function(event) {
  		//console.log(event.latLng.lat()+","+event.latLng.lng());
  		// Set the coordinates values in the form
  		$("#poi_lat").val(event.latLng.lat().toFixed(5));
		$("#poi_lon").val(event.latLng.lng().toFixed(5));
		// Delete the marker from the map, if exists
  		deleteMarkers();
  		// Add a marker on the map
  		var marker = new google.maps.Marker({
      			position: event.latLng, 
      			map: map
  		});
  		markers.push(marker);
	});
}

// Sets the map on all markers in the array.
function setAllMap(map) {
  for (var i = 0; i < markers.length; i++) {
    markers[i].setMap(map);
  }
}

// Deletes all markers in the array by removing references to them.
function deleteMarkers() {
  setAllMap(null);
  markers = [];
}

google.maps.event.addDomListener(window, 'load', initialize);