/**
 * ******************************************************************************************
 * Script che utilizza un elemento geometrico (poligono o box) per interrogare/selezionare
 * l'area sottostante.
 * Le funzioni drawQueryPolygon e updateQueryPolygono servono, rispettivamente, per disegnare
 * il poligono selezione dell'area di interesse.
 * L'interrogazione per mezzo del box non ha una funzione geometrica in questo script perch
 *  sufficiente lanciare la funzione di callback una volta acquisito l'output dello script
 * in js/utils/dragselection.js.
 * Le funzioni di callback sono queryPolygonCallback e queryBoxCallback
 * ******************************************************************************************
 * Autore: Alessio Di Lorenzo
 * Data ultima modifica: 14/05/2010
 * ******************************************************************************************
 */

/*
 * Dati globali
 * ************
 */
var qPolygon;

/*
 * Query spaziale con il poligono
 * ******************************
 */
function drawQueryPolygon() {
	qPolygon && gmap.removeOverlay(qPolygon);
    // Aggiunge il poligono alla mappa
   	qPolygon = new GPolygon([], "#FF0000", 2, 1.0, "#FF0000", 0.5);
   	gmap.addOverlay(qPolygon);
	// Abilita la creazione del poligono
	qPolygon.enableDrawing();
	// Registra l'evento "endline" per lanciare la funzione di callback
   	GEvent.addListener(qPolygon, "endline",queryPolygonCallback);
}
function updateQueryPolygon() {
	//Abilita la modifica del poligono creato
    qPolygon.enableEditing({onEvent: "mouseover"});
    qPolygon.disableEditing({onEvent: "mouseout"}); 
	//Crea un listener che rilancia la funzione di callback ad ogni spostamento dei nodi
    GEvent.addListener(qPolygon, "lineupdated",queryPolygonCallback); 
}
function queryPolygonCallback() {
	updateQueryPolygon();
}

/*
 * Query spaziale con il box
 * *************************
 */
function queryBoxCallback() {
	console.log(selectedArea);
};